#pragma once
#ifndef DEVICE_UPDATE_STRUCTS_H
#define DEVICE_UPDATE_STRUCTS_H

#include "exchange_structs.h"
#include "common/software_info.h"

namespace Datafox
{

#pragma pack(push, 1)

struct StructDeviceUpdateNode
{
    StructStructHeader header;                   ///< Strukturheader
    unsigned int offsetSegmentFirmware;          ///< Offset auf StructDeviceUpdateSegmentFirmware: Firmwareprogramm.
    unsigned int offsetSegmentArray;             ///< Offset auf StructArray für die StructDeviceUpdateSegment: Zusaetzliche Daten wie Fonts, Grafiken etc.
}; // 12 Byte

struct StructDeviceUpdateSegmentFirmware
{
    StructStructHeader header;      ///< Strukturheader
    StructSoftwareInfo softwareInfo;///< Softwareinformation zur enthaltenen Anwendungsfirmware.
    char version[32];               ///< Firmwareversion als String, im Beispielformat: "04.00.23.03\0"
    char timestamp[20];             ///< Datetime vom Build, im Format "2005-01-25 07:00:00\0"
    unsigned int size;              ///< Anzahl Byte Segmentdaten.
    unsigned int crc32;             ///< 32bit CRC Pruefsumme der Segmentdaten.
}; // 115 Byte

struct StructDeviceUpdateSegment
{
    StructStructHeader header;      ///< Strukturheader
    unsigned short type;            ///< Inhalt des Segmentes. 2 = Firmware, 11 = Texte, etc..
    unsigned int size;              ///< Anzahl Byte Segmentdaten.
    unsigned int crc32;             ///< 32bit CRC Pruefsumme der Segmentdaten.
}; // 14 Byte

#pragma pack(pop)

}

#endif
