#include "file/interface/data_flash.h"
#if !defined(_MSC_VER) && !defined(__MINGW32__)
#include <string.h>
#endif


CDataFlash::CDataFlash()
{
    Reset( DATAFLASH_V3_SIZE );
}

CDataFlash::~CDataFlash()
{
}

void CDataFlash::Reset( unsigned int size )
{
    // Basisadresse auf 0 setzen
    m_baseAddress = 0;
    // Speichergroesse entsprechend anpassen.
    m_mem.resize( size );
    m_memUse.resize( size / 32 + ((size % 32) ? 1 : 0) );
    // Speicher initialisieren
    std::fill( m_mem.begin(), m_mem.end(), 0xFF );
    std::fill( m_memUse.begin(), m_memUse.end(), 0 );
}

void CDataFlash::SetMemUsebit(unsigned int address)
{
    address -= m_baseAddress;
    m_memUse[address / 32] |= (1 << (address % 32));
}

unsigned char CDataFlash::GetMemUsebit(unsigned int address)
{
    address -= m_baseAddress;
    return (m_memUse[address / 32] & (1 << (address % 32))) ? 1 : 0;
}

unsigned int CDataFlash::GetMemFirstAddress()
{
    unsigned int address, firstAddress =  m_baseAddress;
    for (address=0; address < m_mem.size(); address++) {

        if (GetMemUsebit(address + m_baseAddress)) {

            firstAddress = address + m_baseAddress;
            break;
        }
    }

    return firstAddress;
}

unsigned int CDataFlash::GetMemLastAddress()
{
    unsigned int address, lastAddress = m_baseAddress;
    for (address=0; address < m_mem.size(); address++) {

        if (GetMemUsebit(address + m_baseAddress)) {

            lastAddress = address + m_baseAddress;
        }
    }

    return lastAddress;
}
